OPTIONS SHORT CIRCUIT
-- Modules importes

-- Version programme
DEFINE cVersion   STRING  ='Scrolling performances (Scrolling - v1.00 - 26/08/2022)'
-- Dfinition des types
TYPE tScrolling RECORD
     numart          STRING                
    ,libart          STRING                
    ,orgart          STRING                
    ,embart          STRING                
    ,prvach          DECIMAL(10,4)         
    ,prvnet          DECIMAL(10,4)         
    ,prvmrg          DECIMAL(6,2)          
    ,nouach          DECIMAL(10,4)         
    ,noudif          DECIMAL(10,4)         
    ,nounet          DECIMAL(10,4)         
    ,noumrg          DECIMAL(6,2)
    ,codmso          CHAR(1)
    ,libunt          STRING                
    ,prvqte          DECIMAL(10,4)         
    ,newqte          DECIMAL(10,4)         
    ,difqte          DECIMAL(10,4)         
    ,qtetot          INTEGER
    ,stacaf          INTEGER               
    ,catprx          SMALLINT              
    ,serart          INTEGER               
    ,valdate         DATE                  
    ,pctqte1         STRING                
    ,newsta          SMALLINT              
    ,mrgold          DECIMAL(8,2)          
    ,mrgnew          DECIMAL(8,2)          
    ,valsai          STRING                
    ,flgprx          BOOLEAN               
    ,savnounet       DECIMAL(10,4)         
    ,savtotqte       INTEGER               
    ,priceref        DECIMAL(10,4)         
    ,priceqty        DECIMAL(10,4)         
     END RECORD
TYPE cScrolling RECORD
     numart          STRING
    ,libart          STRING
    ,orgart          STRING
    ,embart          STRING
    ,prvach          STRING
    ,prvnet          STRING
    ,prvmrg          STRING
    ,nouach          STRING
    ,noudif          STRING
    ,nounet          STRING
    ,noumrg          STRING
    ,codmso          STRING
    ,libunt          STRING
    ,prvqte          STRING
    ,newqte          STRING
    ,difqte          STRING
    ,qtetot          STRING
    ,stacaf          STRING
     END RECORD
-- Records pour curseurs SQL
DEFINE rScrolling RECORD
     serart          INTEGER
    ,staart          CHAR(1)
    ,rmqart          STRING
    ,derach          DATE
    ,prvach          DECIMAL(10,4)
    ,prvnet          DECIMAL(10,4)
    ,prvmkp          DECIMAL(10,4)
    ,nouach          DECIMAL(10,4)
    ,nounet          DECIMAL(10,4)
    ,newmkp          DECIMAL(10,4)
    ,staqte          DECIMAL(10,2)
    ,staqtp          DECIMAL(10,2)
    ,prvqte          DECIMAL(10,4)
    ,newqte          DECIMAL(10,4)
    ,refcli          STRING
    ,lstdat          DATETIME YEAR TO DAY
    ,ordart          INTEGER
    ,fstdat          DATE
    ,numart          INTEGER
    ,libart          STRING
    ,orgart          STRING
    ,embart          STRING
    ,infart          STRING
    ,libunt          STRING
    ,catprx          SMALLINT
    ,valdate         DATE
    ,codmso          CHAR(1)
    ,priceref        DECIMAL(10,4)
    ,priceqty        DECIMAL(10,4)
    ,flgprx          BOOLEAN
     END RECORD

DEFINE vScrolling       DYNAMIC ARRAY OF tScrolling
DEFINE aScrolling       DYNAMIC ARRAY OF cScrolling

MAIN
  DEFER INTERRUPT
  DEFER QUIT
  OPTIONS INPUT WRAP
  OPTIONS FIELD ORDER FORM
  CLOSE WINDOW SCREEN

  CALL Load_Scrolling()
  OPEN WINDOW wScrolling WITH FORM 'Scrolling'
  CALL ui.Window.getCurrent().setText(cVersion)
  DIALOG ATTRIBUTES(UNBUFFERED)
    INPUT ARRAY vScrolling FROM sr_Scrolling.*  ATTRIBUTES(APPEND ROW = FALSE,INSERT  ROW = FALSE,DELETE ROW = FALSE)
    END INPUT
    --BEFORE DIALOG
    --  CALL DIALOG.setArrayAttributes('sr_Scrolling', aScrolling)
    ON ACTION Quitter
      EXIT DIALOG
  END DIALOG
  CLOSE WINDOW wScrolling
END MAIN

{Chargement des tableaux ...}
FUNCTION Load_Scrolling()
  DEFINE i     SMALLINT
  DEFINE ch_in base.Channel

  CALL vScrolling.clear()
  CALL aScrolling.clear()
  LET ch_in = base.Channel.create()
  CALL ch_in.setDelimiter("|")
  CALL ch_in.openFile("Scrolling.unl","r")
  {Chargement des articles du catalogue ...}
  LET i = 0
  WHILE ch_in.read(rScrolling)
     LET i += 1
     LET vScrolling[i].serart    = rScrolling.serart
     LET vScrolling[i].flgprx    = rScrolling.flgprx
     LET vScrolling[i].numart    = rScrolling.numart USING '&&&&&&'
     LET vScrolling[i].libart    = rScrolling.libart
     LET vScrolling[i].orgart    = rScrolling.orgart
     LET vScrolling[i].embart    = rScrolling.embart
     LET vScrolling[i].prvach    = rScrolling.prvach
     LET vScrolling[i].nouach    = rScrolling.nouach
     LET vScrolling[i].prvnet    = rScrolling.prvnet
     LET vScrolling[i].savnounet = rScrolling.nounet
     LET vScrolling[i].codmso    = rScrolling.codmso
     LET vScrolling[i].savtotqte = rScrolling.staqte + rScrolling.staqtp
     LET vScrolling[i].valdate   = rScrolling.valdate
     LET vScrolling[i].libunt  = rScrolling.libunt
     LET vScrolling[i].prvqte  = rScrolling.prvqte
     LET vScrolling[i].newqte  = rScrolling.newqte
     LET vScrolling[i].qtetot  = rScrolling.staqte  + rScrolling.staqtp
     LET vScrolling[i].stacaf  = rScrolling.staqte * rScrolling.prvnet
     LET vScrolling[i].catprx  = rScrolling.catprx
  END WHILE
  CALL ch_in.close()
END FUNCTION

